libm: Fix a typo in MLINKS name.
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 2.10 to later versions               +
13 +-----------------------------------------------------------------------+
14
15 SEVERAL ISA DRIVERS REMOVED
16 ---------------------------
17
18 The following ISA only drivers have been removed along with a couple of
19 associated userland tools:
20
21 aha(4)
22 asc(4) & sasc(1)
23 ctx
24 dgb(4)
25 el(4)
26 gpib
27 gsc(4) & sgsc(1)
28 ie(4)
29 labpc(4)
30 le(4)
31 mse(4)
32 rc(4)
33 rdp(4)
34 spigot
35 tw(4) & xten(1) & xtend(8)
36 wl(4) & wlconfig(8)
37 wt(4)
38
39 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
40 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
41 file.
42
43 If buildkernel complains about any of these drivers, just remove them
44 from your kernel configuration.
45
46 BINUTILS 2.20
47 -------------
48 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
49 values of BINUTILSVERS are now binutils221 and binutils222 (default).
50
51 +-----------------------------------------------------------------------+
52 +         UPGRADING DRAGONFLY FROM 2.8 to later versions                +
53 +-----------------------------------------------------------------------+
54
55 GCC 4.4 & BINUTILS 2.21
56 -----------------------
57
58 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
59 been made DragonFly's default Binutils.
60
61 That means that any settings that set CCVER to 'gcc44' are not needed
62 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
63 GCC 4.1.
64
65 It also means that 'binutils221' as a value for BINUTILSVER has no
66 effect anymore. 2.17 has been removed and 'binutils220' is available
67 as an option.
68
69 The NO_GCC44 option has been removed and will not affect the build
70 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
71 building in a similar fashion.
72
73 Note that you must do a full buildworld/buildkernel for upgrading.
74
75 pkg_radd settings
76 -----------------
77
78 The config file for pkg_radd has moved from /etc/settings.conf to 
79 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
80 if this is needed.  This warning only applies if /etc/settings.conf 
81 exists.  pkg_radd will continue to work with defaults.
82
83 +-----------------------------------------------------------------------+
84 +         20100927                                                      +
85 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
86 +-----------------------------------------------------------------------+
87
88 OpenSSL
89 --------
90
91 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
92 This shouldn't break any 3rd-party software, but you'll need to recompile your
93 3rd-party software if you want it to link against the new version of OpenSSL.
94
95 Loader
96 -------
97
98 A new loader (dloader) has been added which better handles booting from
99 multiple kernel/module versions.
100
101 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
102
103         cd /usr/src
104         make buildworld
105         make installworld
106         make upgrade
107         make buildkernel KERNCONF=<KERNELNAME>
108         make installkernel KERNCONF=<KERNELNAME>
109
110 Note that you must installworld and run the 'upgrade' target before
111 installing the new kernel.
112
113 BIND
114 -----
115
116 BIND has been removed from the base system.  The ldns and drill tools have 
117 been added for basic functionality.  Use 'drill' where you would normally 
118 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
119 net/bind95, net/bind96, or net/bind97 as of this writing.
120
121 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
122 include BIND as a pkgsrc package.
123
124 +-----------------------------------------------------------------------+
125 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
126 +                               GENERAL                                 +
127 +-----------------------------------------------------------------------+
128
129 Instructions on how to obtain and maintain DragonFly source code using git
130 are in the development(7) manual page.
131
132 To upgrade a DragonFly system from sources you run the following sequence:
133
134         cd /usr/src
135         make buildworld
136         make buildkernel KERNCONF=<KERNELNAME>
137         make installkernel KERNCONF=<KERNELNAME>
138         make installworld
139
140 You will also want to run the 'upgrade' target to upgrade your /etc and the
141 rest of your system.  The upgrade target is aware of stale files created by
142 older DragonFly installations and should delete them automatically.
143
144         make upgrade
145
146 See the build(7) manual page for further information.
147
148 Once you've done a full build of the world and kernel you can do incremental
149 upgrades of either by using the 'quickworld' and 'quickkernel' targets
150 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
151 the quick targets, try updating your repo first, and then a full buildworld
152 and buildkernel as shown above, before asking for help.
153
154 +-----------------------------------------------------------------------+
155 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
156 +-----------------------------------------------------------------------+
157
158 In 2.1 kernel and modules has moved to boot directory.  For most cases
159 this is handled automatically by 'make upgrade'.  A few cases needs manual
160 intervention:
161
162  * When installing a kernel without first doing a make buildworld,
163    installworld and upgrade to the same DESTDIR as kernel:
164    make DESTDIR/boot directory and move kernel and modules into this boot
165    directory; also move kernel.old and modules.old.
166    Typical example is vkernel(7), use (no modules used):
167
168         cd /var/vkernel
169         mkdir boot
170         chflags noschg kernel
171         mv kernel kernel.old boot
172         chflags schg boot/kernel
173         
174  * When using a boot-only partition, /boot/loader.rc needs to be edited:
175    delete occurrences of '/boot/'.
176    These occurences can normally be deleted in any case, see loader(8).
177
178 +-----------------------------------------------------------------------+
179 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
180 +-----------------------------------------------------------------------+
181
182 In 1.9 major changes to the disk management infrastructure have taken
183 place.  make upgrade may not catch all of your disk devices in /dev,
184 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
185 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
186 and MAKEDEV no longer exists.
187
188 The biggest changes in 1.9 are:
189
190 (1) That whole-slice devices such as da0s1 no longer share the same device
191     id as partition c devices such as da0s1c.
192
193 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
194     with no snooping or reserved sectors.  Consequently you cannot run
195     disklabel on this device.  Instead you must run disklabel on a
196     whole-slice device.
197
198 (3) The 'compatibility' partitions now use slice 0 in the device name,
199     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
200     accessing the disklabel for the compatibility partitions must be
201     done via slice 0 (da0s0).
202
203 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
204     and CCD now run through the disk management layer and are assigned
205     real disk management devices.   VN and CCD in particular do not usually
206     use a MBR and disklabels must be accessed through the compatibility
207     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
208     don't name it 'ccd0s0' in the config file.
209
210 Generally speaking, you have to get used to running fdisk and disklabel on
211 the correctly specified device names.  A lot of the wiggle, such as running
212 disklabel on a partition, has been removed.
213
214 +-----------------------------------------------------------------------+
215 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
216 +-----------------------------------------------------------------------+
217
218 > Kerberos IV
219 -------------
220
221 Kerberos IV (eBones) was removed from the tree, please consider moving to
222 Kerberos 5 (Heimdal).
223
224 > Package Management System
225 ---------------------------
226
227 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
228 management system.  The necessary tools to build and maintain packages
229 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
230 directories are in your PATH variable.
231
232 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
233 the tarball from NetBSD:
234
235         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
236         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
237
238 This tree can then be kept up to date with cvs update:
239
240         cd /usr/pkgsrc; cvs up
241
242 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
243 build and install the pkgsrc bootstrap manually:
244
245         cd /usr/pkgsrc/bootstrap
246         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
247
248 +-----------------------------------------------------------------------+
249 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
250 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
251 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
252 +-----------------------------------------------------------------------+
253
254 The compatibility shims for the build environment have been removed, you
255 have to update to DragonFly 1.2 release branch first.
256
257 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
258 The existing configuration can be converted using /etc/pam.d/convert.sh.
259 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
260 the pam_skey.so module was retired, you have to remove it manually from
261 your configuration, when you convert it.
262
263 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
264 ---------------------
265
266 The following users may be missing from your password file.  Use vipw and
267 add any that are missing:
268
269 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
270 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
271
272 The following groups may be missing from your group file.  Use vi /etc/group
273 and add any that are missing:
274
275 smmsp:*:25:
276 authpf:*:63:
277 _pflogd:*:64:
278
279
280 > Upgrading to DragonFly from FreeBSD
281 ---------------------
282
283 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
284 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
285 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
286 make depend information, it starts from scratch, so no pre-cleaning of the
287 object hierarchy is necessary.
288
289         # get the CVS repository (it is placed in /home/dcvs, 500MB).
290         # Please use the -h option and a mirror site to pull the 
291         # initial repository, but feel free to use the main repository
292         # machine to pull updates.
293         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
294         # install the source from the CVS hierarchy (remove preexisting
295         # FreeBSD src first) (500MB)
296         cd /usr
297         rm -rf src
298         cvs -R -d /home/dcvs checkout -P src
299
300         # build it (500MB used in /usr/obj)
301         #
302         cd /usr/src
303         make buildworld
304         make buildkernel KERNCONF=<KERNELNAME>
305
306 Once you have built DragonFly you have to install it over FreeBSD.  Since
307 DragonFly does not track changes made by FreeBSD to its include file 
308 hierarchy and include file pollution can cause all sorts of unexpected
309 compilation issues to come up, it is best to wipe your include hierarchy
310 prior to installing DragonFly.  Note that you should not wipe any installed
311 FreeBSD header files or binaries until after you have successfully completed
312 the build steps above.
313
314         rm -rf /usr/include
315         mkdir /usr/include
316         make installkernel KERNCONF=<KERNELNAME>
317         make installworld
318
319 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
320 will unconditionally upgrade the /etc files that sysops do not usually
321 mess around with, such as the files in /etc/rc.d.  It will also remove any
322 obsolete files such as utilities and manpages that have been removed from
323 the system since the version you're coming from.  If you are unsure we 
324 recommend that you make a backup of at least your /etc before applying
325 this step.  Note that DragonFly's RC system is basically RCNG from
326 FreeBSD-5, but there are some differences in the contents of the RC files.
327
328         make upgrade
329
330 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
331 Doing so might leave your system in an unusable state.
332
333 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
334 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
335 report these files to the DragonFly developers so that they can be added to
336 the 'upgrade' target.
337